﻿#region Usings
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Windows.Forms;
using System.IO;
using System.Net.Sockets;
using tcpServer;

using System.Drawing.Imaging;
using System.Drawing.Drawing2D;

using ThermalCamera;
using ThermoVision_JoeC;
#endregion
using System.Runtime.InteropServices;
namespace SeekThermal_Form
{
    public partial class MainForm : Form
    {
		#region <<<Vars>>>
		readonly int W=160, H=120;
        i3ThermalExpertClass thermal;
//        Thread thermalThread;
        System.Diagnostics.Stopwatch STWatch = new System.Diagnostics.Stopwatch();
//        int frameCount;
//        bool stopThread;
//        
//        ThermalFrame lastFrame;
        bool LockCtrl = false;
        delegate void Dele_V_Bitmap(Bitmap bmp);
        delegate void Dele_V_TF(ThermalFrame TF);
        delegate void Dele_V_B(byte[] Data);
//        UInt16[,] VARs.TempRaw;
//        UInt16[,] LastLoaded_Uint16;
        short[,] CalOffsetMap;
        bool[,] CalDefPixelMap=new bool[209,157];
        bool[,] CalDefPixelMapbase=new bool[209,157];
		#endregion
		
		#region Form
        public MainForm()
        {
            InitializeComponent();
            Kernel_DrawPalette(); //init palette
//            Kernel_readCalData();
        }
        void MainFormShown(object sender, EventArgs e)
		{
        	tcpServer1.OnConnect += new tcpServer.tcpServerConnectionChanged(tcpServer1_OnConnect);
        	tcpServer1.OnDataAvailable += new tcpServer.tcpServerConnectionChanged(tcpServer1_OnDataAvailable);
			Btn_SetPortClick(null,null);
		}
        void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
        	timer_TCP.Enabled=false;
//            stopThread = true;
			try {
				tcpServer1.Close();
			} catch (Exception) {
				
			}
            if (thermal != null) {
				while (thermal.Streaming) {
					thermal.Streaming=false; Thread.Sleep(100);
				}
//                if (thermalThread!=null) {
//        			thermalThread.Join(500);
//        		}
            }
        }
        
        void Event_SeekStreamRecived()
		{
        	//byte BeginInvoke(new Dele_V_B(SeekStream_GetByteArraybytes),new object[]{thermal.LastData} );
        	BeginInvoke(new Dele_V_TF(SeekStream_GetByteArray),new object[]{thermal.LastFrame} );
		}
        void old_Kernel_readCalData()
        {
        	if (!File.Exists("Cal_OffsetMap.dat")) { return; }
//        	if (lastFrame==null) {
//        		return;
//        	}
        	FileStream FS = new FileStream("Cal_OffsetMap.dat",FileMode.Open);
        	if (FS.Length==0) { return; }
        	byte[] inhalt = new byte[FS.Length];
        	FS.Read(inhalt,0,(int)FS.Length-1);
        	CalOffsetMap=new short[206,156];
			FS.Close();
			
			int x=0,y=0;
        	for (int i =0;i<inhalt.Length-1 ;i+=2 ) {
				short val = (short)((inhalt[i]<<8|inhalt[i+1])-32767);
				CalOffsetMap[x,y]=val;
//				y++;
//                if (y==Height) {
//                	x++;
//                	if (x==Width) {
//                		break;
//                	}
//                	y=0;
//                }
				x++;
                if (x==206) {
                	y++;
                	if (y==156) {
                		break;
                	}
                	x=0;
                }
        	}
			Kernel_Draw_OffsetMap();
			
			if (!File.Exists("Cal_DefpixelMap.dat")) { return; }
			StreamReader txt = new StreamReader("Cal_DefpixelMap.dat");
			string[] inhaltS = txt.ReadToEnd().Split('\n');
			txt.Close();
			y=0;
			foreach(string S in inhaltS) {
				x=0;
				foreach(char C in S) {
					switch (C) {
						case '_': CalDefPixelMap[x,y]=false; x++; break;
						case '#': CalDefPixelMap[x,y]=true; x++; break;
					}
				}
				y++;
			}
			
        	Kernel_Draw_DefPixMap();
			
//			CalGainmap_processed=new float[CalGainmap_Uint16.Length];
//			float max=CalGainmap_Uint16[0];
//			float min=CalGainmap_Uint16[1];
//			float HalfMax=(((CalGainmap_Uint16[0]-min)/max))/2;
//			for (int i =0;i<CalGainmap_Uint16.Length ;i++ ) {
//				float val = CalGainmap_Uint16[i];
//				CalGainmap_processed[i]=(((val-min)/max))-HalfMax+1f;
//			}
        }
        
        void Btn_GetFrame_AsByteArrayClick(object sender, EventArgs e)
        {
//        	stopThread=false;
			ThermalFrame TF = thermal.Grab_VisualFrame();
			SeekStream_GetByteArray(TF);
			CalDefPixelMap=thermal.DeathPixMap;
        	Kernel_Draw_DefPixMap();
			return;
        }
        //Thread streaming
        
        void SeekStream_GetByteArray(ThermalFrame TF)
        {
        	if (TF==null) { return; }
        	VARs.TempRaw=TF.Data;
        	label_sens_lo.Text=TF.i3TE_FistPix.ToString();
//        	label_devTemp.Text=TF.DevTemp.ToString()+"_"+TF.FrameCnt.ToString();
//        	if (thermal.NucState==3) {
//        		PicBox_ID1.Image=Kernel_DrawImage();
//        		CalDefPixelMap=thermal.DeathPixMap;
//        		Kernel_Draw_DefPixMap();
//        	}
//			if (thermal.NucState!=0) { return; }
//        	if (thermal.LastFrameStatusByte!=(byte)num_frameID.Value) { return; }
			label_framedroped.Text= frameDroped.ToString() +" / " + TF.i3TE_FistPix.ToString();
			label_sens_hi.Text =  TF.MaxValue.ToString();
			label_sens_lo.Text =  TF.MinValue.ToString();
			Kernel_PreProcessImage();
    		PicBoxMain.Image=Kernel_DrawImage();
        }
        #endregion
        
        
		
        
        #region Get_and_Process_ByteArray
        UInt16[,] LastDataIn_Uint16;
        bool doGetRefFrame=false;
        //RANDOM N
        void Kernel_PreProcessImage()
        {
			if (VARs.TempRaw==null) { return; }
			
            // Display last sensor min/max values.

//            if (chk_useMedian.Checked) {
//            	sub_PreProcessMedian();
//            	sub_PreProcessMedian();
//            	sub_PreProcessMedian();
//    		}
            
//			if (chk_qualiLog.Checked) {
//				ushort minValue = 0xFFFF;
//                ushort maxValue = 0x0000;
//                for (int y = 20; y < 130; y++) {
//                    for (int x = 20; x < 180; x++) {
//                        ushort val = VARs.TempRaw[x,y];
//                        if (val < minValue) minValue = val;
//                        if (val > maxValue) maxValue = val;
//                        //data[2+ y * 206 + x]=0;
//                    }
//                }
//                if (MaxRaw<(maxValue-minValue)) { MaxRaw=maxValue-minValue; }
//			}
            if (chk_useRefFrame.Checked&&!doGetRefFrame) {
				if (CalOffsetMap==null) {
					chk_useRefFrame.Checked=false; return;
				}
            	for (int y = 0; y < H; y++) {
	                for (int x = 0; x < W; x++) {
	        			int val = (VARs.TempRaw[x,y]-CalOffsetMap[x,y]);
	        			if (val<0) { val=0; } if (val>0xffff) { val=0xffff; }
	        			VARs.TempRaw[x,y]=(ushort)val;
	                }
	            }
            }
            
            if (chk_useMedian.Checked) {//&&!doGetRefFrame
				int medians = (int)num_medians.Value;
				for (int x = 0; x < medians; x++) {
//					sub_PreProcessMedianSpecial();
					sub_PreProcessMedianFull();
					//sub_PreProcessMedian();
					//VARs.TempRaw=thermal.DataProc_Median(VARs.TempRaw);
                }
    		}
    		if (chk_useMedian2.Checked) {//&&!doGetRefFrame
				int medians = (int)num_mediansSpec.Value;
				for (int x = 0; x < medians; x++) {
					sub_PreProcessMedianSpecial();
					//sub_PreProcessMedian();
					//VARs.TempRaw=thermal.DataProc_Median(VARs.TempRaw);
//					VARs.TempRaw=thermal.DataProc_MedianReplace(VARs.TempRaw,(int)num_mediansDiff.Value);
                }
    		}
            if (chk_useENH.Checked&&!doGetRefFrame) {
            	sub_PreProcessENH();
            }
            // Recompute the min max after the image is all fixed
            // unless the sliders have overriden values, then it doesn't matter.
            if (chk_AutoRange.Checked) {
                ushort val;
                ushort minValue = 0xFFFF;
                ushort maxValue = 0x0000;
                for (int y = 10; y < 110; y++) {
                    for (int x = 10; x < 150; x++) {
                        val = VARs.TempRaw[x,y];
                        if (val < minValue) minValue = val;
                        if (val > maxValue) maxValue = val;
                        //data[2+ y * 206 + x]=0;
                    }
                }
                if (MaxRef<(maxValue-minValue)) { MaxRef=maxValue-minValue; }
                trackBar_max.Value = maxValue;
                trackBar_min.Value = minValue;
            }
            
            
            if (doGetRefFrame) {
            	doGetRefFrame=false;
            	Kernel_DoCalibration();
            }
            
            if (chk_IP_Median.Checked) {
            	VARs.Process_RawMedian();
            }
            if (chk_IP_Convolution.Checked) {
            	double[,] Kernel = new double[,] 
            	{
            		{(double)num_IP_Conv9.Value-10d,(double)num_IP_Conv6.Value-10d,(double)num_IP_Conv3.Value-10d},
            		{(double)num_IP_Conv8.Value-10d,(double)num_IP_Conv5.Value-10d,(double)num_IP_Conv2.Value-10d},
            		{(double)num_IP_Conv7.Value-10d,(double)num_IP_Conv4.Value-10d,(double)num_IP_Conv1.Value-10d}
            	};
            	
            	VARs.Process_Convolution(Kernel);
            }
            if (chk_IP_GausBlur.Checked) {
//            	double[,] ConvSobelWE = new double[,]{{-1,0,1},{-1,0,1},{-1,0,1}};
//            	double[,] ConvSobelNS = new double[,]{{-1,-1,-1},{0,0,0},{1,1,1}};
VARs.Process_Gausian((double)num_IP_GausSigma.Value);
//            	ushort[,] ProcWE = VARs.Process_ConvolutionExtern(ConvSobelWE);
//            	ushort[,] ProcNS = VARs.Process_ConvolutionExtern(ConvSobelNS);
//            	
//            	for (int y = 0; y < 156; y++) {
//	                for (int x = 0; x < 206; x++) {
//            			int val = VARs.TempRaw[x,y]+(int)((double)(ProcWE[x,y]+ProcNS[x,y])/1000d);
//            			if (val<0) { val=0; } if (val>65535) { val=65535; }
//            			VARs.TempRaw[x,y]=(ushort)val;
//	                }
//	            }
            }
            if (chk_IP_BinarySwitch.Checked) {
            	ushort schwelle = (ushort)num_IP_BinarySwitch.Value;
            	for (int y = 0; y < 156; y++) {
	                for (int x = 0; x < 206; x++) {
            			if (VARs.TempRaw[x,y]>schwelle) {
            				VARs.TempRaw[x,y]=(ushort)trackBar_max.Value;
            			} else {
            				VARs.TempRaw[x,y]=(ushort)trackBar_min.Value;
            			}
	                }
	            }
            }
        }
        void sub_PreProcessENH()
        {
        	//Frame without edges
        	float multi = (float)num_T.Value;
        	ushort val;
            ushort minValue = 0xFFFF;
            ushort maxValue = 0x0000;
            for (int y = 20; y < 130; y++) {
                for (int x = 20; x < 180; x++) {
                    val = VARs.TempRaw[x,y];
                    if (val < minValue) minValue = val;
                    if (val > maxValue) maxValue = val;
                    //data[2+ y * 206 + x]=0;
                }
            }
            int startVal = ((maxValue-minValue)/2)+minValue;
            int stop_x=205;
			int stop_y=155;
			ushort[,] Proc = new ushort[206,156];
            for (int x = 1; x<stop_x; x++) {
				for (int y = 1; y<stop_y; y++) {
					float datanew = VARs.TempRaw[x,y];
					float val6 = VARs.TempRaw[x,y]-VARs.TempRaw[x+1,y];
					datanew+=val6*multi;
					float val4 = VARs.TempRaw[x,y]-VARs.TempRaw[x-1,y];
					datanew+=val4*multi;
					float val2 = VARs.TempRaw[x,y]-VARs.TempRaw[x,y-1];
					datanew+=val2*multi;
					float val8 = VARs.TempRaw[x,y]-VARs.TempRaw[x,y+1];
					datanew+=val8*multi;
					float val1 = VARs.TempRaw[x,y]-VARs.TempRaw[x-1,y-1];
					datanew+=val1*multi;
					float val3 = VARs.TempRaw[x,y]-VARs.TempRaw[x+1,y-1];
					datanew+=val3*multi;
					float val7 = VARs.TempRaw[x,y]-VARs.TempRaw[x-1,y+1];
					datanew+=val7*multi;
					float val9 = VARs.TempRaw[x,y]-VARs.TempRaw[x+1,y+1];
					datanew+=val9*multi;
					Proc[x,y]=(ushort)datanew;
				}
			}
        	for (int y = 1; y < 155; y++) {
                for (int x = 1; x < 205; x++) {
					VARs.TempRaw[x,y]=Proc[x,y];
                }
            }
        }
        void sub_PreProcessMedianFull()
        {
        	long val=0; int cnt=0;
        	ushort[,] Proc = new ushort[thermal.W,thermal.H];
        	//Frame without edges
        	for (int y = 1; y < 155; y++) {
                for (int x = 1; x < 205; x++) {
                    //1  2  3
                    //4  5  6
                    //7  8  9
                    val=0; cnt=0;
                    val += VARs.TempRaw[x-1,y-1]; cnt++;  //1
                    val += VARs.TempRaw[x,y-1]; cnt++;  //2
                    val += VARs.TempRaw[x+1,y-1]; cnt++;  //3
                    val += VARs.TempRaw[x-1,y]; cnt++;  //4
                    val += VARs.TempRaw[x,y]; cnt++;  //5
                    val += VARs.TempRaw[x+1,y]; cnt++;  //6
                    val += VARs.TempRaw[x-1,y+1]; cnt++;  //7
                    val += VARs.TempRaw[x,y+1]; cnt++;  //8
                    val += VARs.TempRaw[x+1,y+1]; cnt++;  //9
                    
                    Proc[x,y] = (ushort)(val/cnt);
                }
            }
        	//edge W --------------------------------------------
    		for (int y = 1; y < 155; y++) {
                val=0; cnt=0;
                val += VARs.TempRaw[0,y-1]; cnt++;  //2
                val += VARs.TempRaw[1,y-1]; cnt++;  //3
                val += VARs.TempRaw[1,y]; cnt++;  //6
                val += VARs.TempRaw[0,y+1]; cnt++;  //8
                val += VARs.TempRaw[1,y+1]; cnt++;  //9
				Proc[0,y] = (ushort)(val/(long)cnt);
            }
        	//edge E --------------------------------------------
    		for (int y = 1; y < 155; y++) {
                val=0; cnt=0;
                val += VARs.TempRaw[204,y-1]; cnt++;  //1
                val += VARs.TempRaw[205,y-1]; cnt++;  //2
                val += VARs.TempRaw[204,y]; cnt++;  //4
                val += VARs.TempRaw[204,y+1]; cnt++;  //7
                val += VARs.TempRaw[205,y+1]; cnt++;  //8
                Proc[205,y] = (ushort)(val/(long)cnt); 
            }
        	//edge N --------------------------------------------
    		for (int x = 1; x < 205; x++) {
                val=0; cnt=0;
                val += VARs.TempRaw[x-1,0]; cnt++;  //4
                val += VARs.TempRaw[x+1,0]; cnt++;  //6
                val += VARs.TempRaw[x-1,1]; cnt++;  //7
                val += VARs.TempRaw[x,1]; cnt++;  //8
                val += VARs.TempRaw[x+1,1]; cnt++;  //9
				Proc[x,0] = (ushort)(val/(long)cnt); 
            }
        	//edge S --------------------------------------------
    		for (int x = 1; x < 205; x++) {
                val=0; cnt=0;
                val += VARs.TempRaw[x-1,154]; cnt++;  //1
                val += VARs.TempRaw[x,154]; cnt++;  //2
                val += VARs.TempRaw[x+1,154]; cnt++;  //3
                val += VARs.TempRaw[x-1,155]; cnt++;  //4
                val += VARs.TempRaw[x+1,155]; cnt++;  //6
				Proc[x,155] = (ushort)(val/(long)cnt); 
            }
        	//übertragen
        	Proc[0,0]=VARs.TempRaw[0,0];
        	Proc[0,155]=VARs.TempRaw[0,155];
        	Proc[205,0]=VARs.TempRaw[205,0];
        	Proc[205,155]=VARs.TempRaw[205,155];
        	for (int y = 0; y < 156; y++) {
                for (int x = 0; x < 206; x++) {
                   VARs.TempRaw[x,y]=Proc[x,y];
                }
            }
        	
        }
        void oldsub_PreProcessMedianSpecial()
        {
        	long val=0; int cnt=0;
        	ushort[,] Proc = new ushort[thermal.W,thermal.H];
        	//edge W --------------------------------------------
    		for (int y = 1; y < 155; y++) {
                val=0; cnt=0;
                val += VARs.TempRaw[0,y-1]; cnt++;  //2
                val += VARs.TempRaw[1,y-1]; cnt++;  //3
                val += VARs.TempRaw[1,y]; cnt++;  //6
                val += VARs.TempRaw[0,y+1]; cnt++;  //8
                val += VARs.TempRaw[1,y+1]; cnt++;  //9
				Proc[0,y] = (ushort)(val/(long)cnt);
            }
        	//edge E --------------------------------------------
    		for (int y = 1; y < 155; y++) {
                val=0; cnt=0;
                val += VARs.TempRaw[204,y-1]; cnt++;  //1
                val += VARs.TempRaw[205,y-1]; cnt++;  //2
                val += VARs.TempRaw[204,y]; cnt++;  //4
                val += VARs.TempRaw[204,y+1]; cnt++;  //7
                val += VARs.TempRaw[205,y+1]; cnt++;  //8
                Proc[205,y] = (ushort)(val/(long)cnt); 
            }
        	//edge N --------------------------------------------
    		for (int x = 1; x < 205; x++) {
                val=0; cnt=0;
                val += VARs.TempRaw[x-1,0]; cnt++;  //4
                val += VARs.TempRaw[x+1,0]; cnt++;  //6
                val += VARs.TempRaw[x-1,1]; cnt++;  //7
                val += VARs.TempRaw[x,1]; cnt++;  //8
                val += VARs.TempRaw[x+1,1]; cnt++;  //9
				Proc[x,0] = (ushort)(val/(long)cnt); 
            }
        	//edge S --------------------------------------------
    		for (int x = 1; x < 205; x++) {
                val=0; cnt=0;
                val += VARs.TempRaw[x-1,154]; cnt++;  //1
                val += VARs.TempRaw[x,154]; cnt++;  //2
                val += VARs.TempRaw[x+1,154]; cnt++;  //3
                val += VARs.TempRaw[x-1,155]; cnt++;  //4
                val += VARs.TempRaw[x+1,155]; cnt++;  //6
				Proc[x,155] = (ushort)(val/(long)cnt); 
            }
        	//übertragen
        	Proc[0,0]=VARs.TempRaw[0,0];
        	Proc[0,155]=VARs.TempRaw[0,155];
        	Proc[205,0]=VARs.TempRaw[205,0];
        	Proc[205,155]=VARs.TempRaw[205,155];
        	//Frame without edges
        	for (int y = 1; y < 155; y++) {
                for (int x = 1; x < 205; x++) {
                    //1  2  3
                    //4  5  6
                    //7  8  9
                    val=0; cnt=0;
                    val += VARs.TempRaw[x-1,y-1]; cnt++;  //1
                    val += VARs.TempRaw[x,y-1]; cnt++;  //2
                    val += VARs.TempRaw[x+1,y-1]; cnt++;  //3
                    val += VARs.TempRaw[x-1,y]; cnt++;  //4
                    val += VARs.TempRaw[x,y]; cnt++;  //5
                    val += VARs.TempRaw[x+1,y]; cnt++;  //6
                    val += VARs.TempRaw[x-1,y+1]; cnt++;  //7
                    val += VARs.TempRaw[x,y+1]; cnt++;  //8
                    val += VARs.TempRaw[x+1,y+1]; cnt++;  //9
                    
                    int Median3x3 = (int)(val/(long)cnt);
                	int diffX = Median3x3-Proc[x-1,y];
                	if (diffX<0) { diffX=0-diffX; }
                	int diffY = Median3x3-Proc[x,y-1];
                	if (diffY<0) { diffY=0-diffY; }
                	if (diffX>diffY) {
	                	if (diffX<(int)num_mediansDiff.Value) {
                			Proc[x,y] = (ushort)((Proc[x,y-1]*3+Median3x3)/4);
	                	} else {
	                		Proc[x,y] = (ushort)((VARs.TempRaw[x,y]*2+Median3x3)/3);
	                	}
                	} else {
                		if (diffX<(int)num_mediansDiff.Value) {
                			Proc[x,y] = (ushort)((Proc[x-1,y]*3+Median3x3)/4);
	                	} else {
	                		Proc[x,y] = (ushort)((VARs.TempRaw[x,y]*2+Median3x3)/3);
	                	}
                	}
                	
                }
            }
        	
        	for (int y = 0; y < 156; y++) {
                for (int x = 0; x < 206; x++) {
                   VARs.TempRaw[x,y]=Proc[x,y];
                }
            }
        	
        }
        void sub_PreProcessMedianSpecial()
        {
        	long val=0; int cnt=0;
        	ushort[,] Proc = new ushort[thermal.W,thermal.H];
        	//edge W --------------------------------------------
    		for (int y = 1; y < 155; y++) {
                val=0; cnt=0;
                val += VARs.TempRaw[0,y-1]; cnt++;  //2
                val += VARs.TempRaw[1,y-1]; cnt++;  //3
                val += VARs.TempRaw[1,y]; cnt++;  //6
                val += VARs.TempRaw[0,y+1]; cnt++;  //8
                val += VARs.TempRaw[1,y+1]; cnt++;  //9
				Proc[0,y] = (ushort)(val/(long)cnt);
            }
        	//edge E --------------------------------------------
    		for (int y = 1; y < 155; y++) {
                val=0; cnt=0;
                val += VARs.TempRaw[204,y-1]; cnt++;  //1
                val += VARs.TempRaw[205,y-1]; cnt++;  //2
                val += VARs.TempRaw[204,y]; cnt++;  //4
                val += VARs.TempRaw[204,y+1]; cnt++;  //7
                val += VARs.TempRaw[205,y+1]; cnt++;  //8
                Proc[205,y] = (ushort)(val/(long)cnt); 
            }
        	//edge N --------------------------------------------
    		for (int x = 1; x < 205; x++) {
                val=0; cnt=0;
                val += VARs.TempRaw[x-1,0]; cnt++;  //4
                val += VARs.TempRaw[x+1,0]; cnt++;  //6
                val += VARs.TempRaw[x-1,1]; cnt++;  //7
                val += VARs.TempRaw[x,1]; cnt++;  //8
                val += VARs.TempRaw[x+1,1]; cnt++;  //9
				Proc[x,0] = (ushort)(val/(long)cnt); 
            }
        	//edge S --------------------------------------------
    		for (int x = 1; x < 205; x++) {
                val=0; cnt=0;
                val += VARs.TempRaw[x-1,154]; cnt++;  //1
                val += VARs.TempRaw[x,154]; cnt++;  //2
                val += VARs.TempRaw[x+1,154]; cnt++;  //3
                val += VARs.TempRaw[x-1,155]; cnt++;  //4
                val += VARs.TempRaw[x+1,155]; cnt++;  //6
				Proc[x,155] = (ushort)(val/(long)cnt); 
            }
        	//übertragen
        	Proc[0,0]=VARs.TempRaw[0,0];
        	Proc[0,155]=VARs.TempRaw[0,155];
        	Proc[205,0]=VARs.TempRaw[205,0];
        	Proc[205,155]=VARs.TempRaw[205,155];
        	//Frame without edges
        	for (int y = 1; y < 155; y++) {
                for (int x = 1; x < 205; x++) {
                    //1  2  3
                    //4  5  6
                    //7  8  9
                    val=0; cnt=0;
                    val += VARs.TempRaw[x-1,y-1]; cnt++;  //1
                    val += VARs.TempRaw[x,y-1]; cnt++;  //2
                    val += VARs.TempRaw[x+1,y-1]; cnt++;  //3
                    val += VARs.TempRaw[x-1,y]; cnt++;  //4
                    val += VARs.TempRaw[x,y]; cnt++;  //5
                    val += VARs.TempRaw[x+1,y]; cnt++;  //6
                    val += VARs.TempRaw[x-1,y+1]; cnt++;  //7
                    val += VARs.TempRaw[x,y+1]; cnt++;  //8
                    val += VARs.TempRaw[x+1,y+1]; cnt++;  //9
                    
                    int Median3x3 = (int)(val/(long)cnt);
                	int diffX = Median3x3-Proc[x-1,y];
                	if (diffX<0) { diffX=0-diffX; }
                	int diffY = Median3x3-Proc[x,y-1];
                	if (diffY<0) { diffY=0-diffY; }
                	bool isHigh = false;
                	if (diffX>diffY) {
	                	if (diffX<(int)num_mediansDiff.Value) {
                			Proc[x,y] = (ushort)((Proc[x,y-1]*3+Median3x3)/4);
	                	} else { isHigh=true; }
                	} else {
                		if (diffX<(int)num_mediansDiff.Value) {
                			Proc[x,y] = (ushort)((Proc[x-1,y]*3+Median3x3)/4);
	                	} else { isHigh=true; }
                	}
                	if (isHigh) {
                		
                		Proc[x,y] = (ushort)((VARs.TempRaw[x,y]*2+Median3x3)/3);
                	}
                }
            }
        	
        	for (int y = 0; y < 156; y++) {
                for (int x = 0; x < 206; x++) {
                   VARs.TempRaw[x,y]=Proc[x,y];
                }
            }
        	
        }
        
        int framecount=0;
//        int MaxRaw=0;
        int MaxRef=0;
        
        Bitmap Kernel_DrawImage()
        {
//        	if (thermal==null) { return null; }
        	UInt16[,] Frame = VARs.TempRaw;
        	bool Interpolate_x4 = chk_InterpolationX2.Checked;
        	PixelData Col = new PixelData();
        	UnsafeBitmap ubmp=null;
        	ubmp = new UnsafeBitmap(W, H);
        	ubmp.LockBitmap();
        	ushort max,min;
        	
        	if (chk_AutoRange.Checked) {
                ushort val;
                min = 0xFFFF;
                max = 0x0000;
	            for (int y = 20; y < 110; y++) {
                    for (int x = 20; x < 150; x++) {
                        val = Frame[x,y];
                        if (val < min) min = val;
                        if (val > max) max = val;
                    }
                }
        	} else {
        		max=(ushort)trackBar_max.Value;
        		min=(ushort)trackBar_min.Value;
        	}
        	
        	// Display displayed data min/max value.
        	
        	if (false) {
	        	decimal TC_off=num_temp_offset.Value;
	            decimal TC_mul=num_temp_multi.Value;
	            decimal Temperatur = ((decimal)max-TC_off)/TC_mul;
	            if (Temperatur<-999) { Temperatur=-999; } if (Temperatur>999) { Temperatur=999; }
	            label_tempmax.Text=Temperatur.ToString();
	            Temperatur = ((decimal)min-TC_off)/TC_mul;
	            if (Temperatur<-999) { Temperatur=-999; } if (Temperatur>999) { Temperatur=999; }
	            label_tempmin.Text=Temperatur.ToString();
        	} else { 
//        		if (thermal.LastFrameStatusByte==6&&chk_qualiLog.Checked) {
//        			string time = STWatch.Elapsed.ToString().Split('.')[0];
//        			txt_frameDataLog.Text+=time+"\t"+MaxRaw+"\t"+MaxRef+"\t"+framecount+"\r\n";
//        		}
//        		framecount=0; MaxRaw=0; MaxRef=0;
        	}
            
            
        	// Scale data to be within [0-255] for LUT mapping.
        	ushort maxmin = (ushort)(max-min);
            if (maxmin<10) { maxmin=10; }// Avoid divide by 0
            for (int y = 0; y < H; y++) {
                for (int x = 0; x < W; x++) {
                    int v = Frame[x,y];
                    
                    v = (v - min) * 256 / maxmin;
                    if (v < 0) { v = 0; }
                    if (v > 255) {  v = 255; }
                    
                    if (lastPalette>1) {
                    	Col.red=map_r[v];
                    	Col.green=map_g[v];
	                    Col.blue=map_b[v];
                    } else { // Greyscale output (would always be limited to 256 colors)
	                    Col.red=(byte)v;
	                    Col.green=(byte)v;
	                    Col.blue=(byte)v;
                    }
                    
                    ubmp.SetPixel(x, y, Col);
                }
            }
        	
        	ubmp.UnlockBitmap();
        	try {
	        	if (chk_BilatSmooth.Checked) {
	        		AForge.Imaging.Filters.BilateralSmoothing BS = new AForge.Imaging.Filters.BilateralSmoothing();
	        		BS.KernelSize=(int)num_BS_kernel.Value;
	        		BS.SpatialFactor=(int)num_BS_SpartFact.Value;
	        		BS.SpatialPower=(int)num_BS_SpartPow.Value;
	        		Bitmap bmp = BS.Apply((Bitmap)ubmp.Bitmap.Clone());
	        		return bmp;
	        	}
        	} catch (Exception ) {
        		
        	}
        	
        	return ubmp.Bitmap;
			//PicBoxMain.Image=ubmp.Bitmap;
        }
        
        
        
        #endregion
        
        #region Tab_Draw_Palette
        byte[] map_r = new byte[256];
        byte[] map_g = new byte[256];
      	byte[] map_b = new byte[256];
      	byte lastPalette = 0;
      	Bitmap Farbscala;
        void TrackBar_maxScroll(object sender, EventArgs e)
        {
        	if (LockCtrl) { return; }
        	if (trackBar_min.Value>trackBar_max.Value) {
        		trackBar_min.Value=trackBar_max.Value;
        	}
        	label_ScaleValues.Text="MaxValue: "+trackBar_max.Value.ToString()+
        		"\r\nMinValue: "+trackBar_min.Value.ToString();
//        	Kernel_DrawImage();
        }
        void TrackBar_minScroll(object sender, EventArgs e)
        {
        	if (LockCtrl) { return; }
        	if (trackBar_min.Value>trackBar_max.Value) {
        		trackBar_max.Value=trackBar_min.Value;
        	}
        	label_ScaleValues.Text="MaxValue: "+trackBar_max.Value.ToString()+
        		"\r\nMinValue: "+trackBar_min.Value.ToString();
//        	Kernel_DrawImage();
        }
        
        //color palette
        void Rad_Pal_All_CheckedChanged(object sender, EventArgs e)
        {
        	Kernel_DrawPalette();
        }
        void panel_PalColAllClick(object sender, EventArgs e)
        {
        	if (colorDialog1.ShowDialog()==DialogResult.OK) {
        		Panel P = sender as Panel;
        		P.BackColor=colorDialog1.Color;
        		rad_Pal_SelfDual.Checked=true;
        		draw_dual_palette(panel_PalCol1.BackColor,panel_PalCol2.BackColor);
        	}
        }
        
        void Kernel_DrawPalette()
        {
        	byte pal = 0;
        	if (rad_Pal_Grayscale.Checked) { pal=1; }
        	if (rad_Pal_Ironbow.Checked) { pal=2; }
        	if (rad_Pal_Rainbow.Checked) { pal=3; }
        	if (rad_Pal_SelfDual.Checked) { pal=4; }
        	if (lastPalette==pal) { return; }
        	lastPalette=pal;
        	switch (lastPalette) {
        		case 1: draw_dual_palette(Color.White,Color.Black); break;
        		case 2: draw_IronBow_palette(); break;
        		case 3: draw_rainbow_palette(); break;
        		case 4: draw_dual_palette(panel_PalCol1.BackColor,panel_PalCol2.BackColor); break;
        	}
//        	Kernel_DrawImage();
        }
        void draw_dual_palette(Color Hot_Col,Color Cold_Col)
		{
			//erstelle ein Bild mit 256 Pixeln, Farbwerte sind von 0-255 (byte)
			//also braucht man 1-256 Pixel zum auswerten
			Farbscala = new Bitmap(30, 256);
			//Grafikobjekte erstellen
			Graphics G = Graphics.FromImage(Farbscala);
			Rectangle rect = new Rectangle(0, 0, 30, 256);
			LinearGradientBrush GB = new LinearGradientBrush(rect, Hot_Col, Cold_Col, LinearGradientMode.Vertical);
			//fülle das rechteck mit den übergebenen farben
			G.FillRectangle(GB, rect);
			Bitmap img = (Bitmap)Farbscala;
			Color col = new Color();
			for (int i = 0; i < 256; i++ ) 
			{
				col = img.GetPixel(1,255-i);
				map_r[i] = col.R;
				map_g[i] = col.G;
				map_b[i] = col.B;
			}
			PicBoxPalette.Image=img;
		}
        void draw_IronBow_palette()
		{	//erstelle ein Bild mit 256 Pixeln, Farbwerte sind von 0-255 (byte)
			//also braucht man 1-256 Pixel zum auswerten
			Farbscala = new Bitmap(30, 256);
			//Grafikobjekte erstellen
			Graphics G = Graphics.FromImage(Farbscala);
			Rectangle rect = new Rectangle(0, 0, 30, 256);
			LinearGradientBrush GB = new LinearGradientBrush(rect, Color.Red, Color.Blue, LinearGradientMode.Vertical);
			//start und endfarbe mit neuen überschreiben
			ColorBlend CB = new ColorBlend();
			CB.Colors = new Color[]
			{
				Color.White,Color.Yellow,Color.Orange,Color.Crimson,Color.DarkViolet,Color.MediumBlue,Color.Black
			};
			//punkte festlegen, an denen die farben sein sollen, was dazwischen liegt
			//wird zum farbverlauf
      		float[] CP = new float[7];
      		//anfags und endpunkte müssen festliegen, 
      		//deshalb sind die anfangs und endfarben auch zweimal vorhanden
      		CP[0] = 0.0f;
      		CP[1] = 0.2f;
      		CP[2] = 0.3f;
      		CP[3] = 0.5f;
      		CP[4] = 0.7f;
      		CP[5] = 0.9f;
      		CP[6] = 1.0f;
      			
      		//werte übergeben
      		CB.Positions = CP;
			GB.InterpolationColors = CB;
			
			//fülle das rechteck mit den übergebenen farben
			G.FillRectangle(GB, rect);
			Bitmap img = (Bitmap)Farbscala;
			Color col = new Color();
			for (int i = 0; i < 256; i++ ) 
			{
				col = img.GetPixel(1,255-i);
				map_r[i] = col.R;
				map_g[i] = col.G;
				map_b[i] = col.B;
			}
			PicBoxPalette.Image=img;
		}
        void draw_rainbow_palette()
		{
			Farbscala = new Bitmap(30, 256);
			//Grafikobjekte erstellen
			Graphics G = Graphics.FromImage(Farbscala);
			Rectangle rect = new Rectangle(0, 0, 30, 256);
			LinearGradientBrush GB = new LinearGradientBrush(rect, Color.Red, Color.Blue, LinearGradientMode.Vertical);
			
			ColorBlend CB = new ColorBlend();
			CB.Colors = new Color[]
			{
				Color.White, Color.White,Color.Red,Color.Gold,Color.Yellow,
				Color.LimeGreen,Color.DodgerBlue,Color.DarkBlue,Color.Black,Color.Black
			};
      		float[] CP = new float[10];
      		CP[0] = 0.0f; CP[9] = 1.0f;
      		for (float i = 1; i < 9; i++ ) {	
      			CP[(int)i] = (float)( (i+-0.75)/7.5 );
      		}
      		CB.Positions = CP; GB.InterpolationColors = CB;
			
			//fülle das rechteck mit den übergebenen farben
			G.FillRectangle(GB, rect);
			Bitmap img = (Bitmap)Farbscala;
			Color col = new Color();
			for (int i = 0; i < 256; i++ ) 
			{
				col = img.GetPixel(1,255-i);
				map_r[i] = col.R;
				map_g[i] = col.G;
				map_b[i] = col.B;
			}
			PicBoxPalette.Image=img;
		}
		#endregion
        #region Tab_RawFrame
        
        #endregion
        
        #region Calibration
        
        
        void Btn_SaveLastByteArrayToDatClick(object sender, EventArgs e)
        {
        	if (VARs.TempRaw==null) { return; }
        	saveFileDialog1.FileName="VARs.TempRaw.dat";
        	if (saveFileDialog1.ShowDialog()!=DialogResult.OK) { return; }
        	bool resp=thermal.SaveFrameToFile(saveFileDialog1.FileName,true);
//        	FileStream FS = new FileStream(saveFileDialog1.FileName,FileMode.Create);
//        	for (int y = 0; y < 156; y++) {
//                for (int x = 0; x < 206; x++) {
//		            int val = VARs.TempRaw[x,y];
//	        		byte B1 = (byte)(val>>8&0xff);
//	        		byte B2 = (byte)(val&0xff);
//	        		FS.WriteByte(B1); FS.WriteByte(B2);
//                }
//            }
//        	FS.Close();
        	
			MessageBox.Show("Save File == "+resp.ToString()+":\r\n"+saveFileDialog1.FileName);
        }
        void Btn_LoadLastByteArrayFromDatClick(object sender, EventArgs e)
        {
        	if (openFileDialog1.ShowDialog()!=DialogResult.OK) { return; }
        	if (!File.Exists(openFileDialog1.FileName)) { return; }
        	ThermalFrame TF = thermal.LoadFrameFromFile(openFileDialog1.FileName);
        	if (TF!=null) {
        		SeekStream_GetByteArray(TF);
        		MessageBox.Show("File loadet:\r\n"+openFileDialog1.FileName);
        	} else {
        		MessageBox.Show("File Not loadet:\r\n"+openFileDialog1.FileName);
        	}
        	
//			Kernel_DrawImage();
			
        	//MessageBox.Show("File loadet:\r\n"+openFileDialog1.FileName);
        }
        void Btn_SaveLastByteArrayToTxtClick(object sender, EventArgs e)
        {
        	if (VARs.TempRaw==null) { return; }
        	saveFileDialog1.FileName="VARs.TempRaw.txt";
        	if (saveFileDialog1.ShowDialog()!=DialogResult.OK) { return; }
        	
        	StreamWriter txt = new StreamWriter(saveFileDialog1.FileName);
        	for (int y = 0; y < 156; y++) {
                for (int x = 0; x < 206; x++) {
    				txt.Write(VARs.TempRaw[x,y].ToString()+"#");
                }
            }
        	txt.Close();
        	
        	MessageBox.Show("File Saved:\r\n"+saveFileDialog1.FileName);
        }  
        
        void Kernel_Draw_OffsetMap()
        {
        	UnsafeBitmap ubmp = new UnsafeBitmap(206, 156);
        	PixelData Col = new PixelData();
        	ubmp.LockBitmap();
            for (int y = 0; y < 156; y++) {
                for (int x = 0; x < 206; x++) {
                    int v = CalOffsetMap[x,y]+128; 
                    
                    if (v < 0) { v = 0; }
                    if (v > 255) {  v = 255; }
					
                    Col.red=(byte)v;
	                Col.green=(byte)v;
	                Col.blue=(byte)v;
                    
	                ubmp.SetPixel(x, y, Col);
                }
            }
        	ubmp.UnlockBitmap();
			PicBox_ID1.Image=ubmp.Bitmap;
        }
        void Kernel_Draw_DefPixMap()
        {
        	UnsafeBitmap ubmp = new UnsafeBitmap(384, 288);
        	PixelData Col = new PixelData();
        	ubmp.LockBitmap();
            for (int y = 0; y < 288; y++) {
                for (int x = 0; x < 384; x++) {
        			if (!CalDefPixelMap[x,y]) {
	        			Col.red=0;
		                Col.green=0;
		                Col.blue=0;
        			} else {
        				Col.red=255;
		                Col.green=255;
		                Col.blue=255;
        			}
					
	                ubmp.SetPixel(x, y, Col);
                }
            }
        	ubmp.UnlockBitmap();
			PicBox_DpixMap.Image=ubmp.Bitmap;
        }
        
        void Btn_CalibrateClick(object sender, EventArgs e)
        {
        	if (VARs.TempRaw==null) { return; }
        	doGetRefFrame=true;
        }
        void Kernel_DoCalibration()
        {
        	FileStream FS = new FileStream("Cal_OffsetMap.dat",FileMode.Create);
        	CalDefPixelMap=new bool[385,289];
        	long Gesamt = 0L; int GesCount = 0;int Tresh = 250;
        	short minValue = 32766;
            short maxValue = -32766;
            for (int y = 0; y < 288; y++) {
                for (int x = 1; x < 384; x++) {
	                int diff = VARs.TempRaw[x,y]-VARs.TempRaw[x-1,y];
	        		if (diff<Tresh||0-diff>Tresh) {
	        			Gesamt+=VARs.TempRaw[x-1,y]; GesCount++;
	                } else { CalDefPixelMap[x,y]=true; }
                }
            }
            
        	int Durchschnitt = (int)(Gesamt/(long)GesCount);
        	
        	CalOffsetMap = new short[385,289];
        	for (int y = 0; y < 288; y++) {
                for (int x = 0; x < 384; x++) {
		            int val = VARs.TempRaw[x,y]-Durchschnitt;
	        		CalOffsetMap[x,y]=(short)val;
	        		if (val < minValue) { minValue = (short)val; } 
	        		if (val > maxValue) { maxValue = (short)val; } 
	        		val+=32767; //offset zum speichern
	        		byte B1 = (byte)(val>>8&0xff);
	        		byte B2 = (byte)(val&0xff);
	        		FS.WriteByte(B1); FS.WriteByte(B2);
                }
            }
        	FS.Close();
        	//Save Def Pixel Map
        	StreamWriter txt = new StreamWriter("Cal_DefpixelMap.dat",false);
        	for (int y = 0; y < 288; y++) {
                for (int x = 0; x < 384; x++) {
	        		if (CalDefPixelMap[x,y]) {
        				txt.Write("#");
	                } else { txt.Write("_"); }
                }
        		txt.WriteLine();
            }
        	txt.Close();
        	
        	Kernel_Draw_OffsetMap();
        	Kernel_Draw_DefPixMap();
        }
        
        #endregion
        
        
        
        void Timer_statusbyteTick(object sender, EventArgs e)
        {
        	if (thermal==null) { return; }
//        	label_dev_statusbyte.Text=thermal.LastFrameStatusByte.ToString();
        	switch (label_dev_statusbyte.Text) {
        		case "3": label_dev_statusbyte.BackColor=Color.LimeGreen; break;
        		case "6": label_dev_statusbyte.BackColor=Color.Gold; break;
        		case "1": label_dev_statusbyte.BackColor=Color.Blue; break;
        		default: label_dev_statusbyte.BackColor=Color.White; break;
        	}
        	label_dev_statusbyte.Refresh();
        }
        
        void Chk_dev_showTFstatusBCheckedChanged(object sender, EventArgs e)
        {
        	timer_statusbyte.Enabled=chk_dev_showTFstatusB.Checked;
        }
        
        
        
        void Btn_CMD_setcmdClick(object sender, EventArgs e)
        {
        	//thermal.SendCMDOperation(0);
        	byte[] args = new byte[4];
//        	args[0]=(byte)num_cmdOperation.Value;
//        	thermal.SendCMD((byte)num_cmd.Value,args);
        	//thermal.SendCMDOperation(1);
        }
        
        
		void Chk_HiFPSModeCheckedChanged(object sender, EventArgs e)
		{
	
		}
		void NumericUpDown1ValueChanged(object sender, EventArgs e)
		{
	
		}
		void Chk_seek_useInternalProcessingCheckedChanged(object sender, EventArgs e)
		{
//			thermal.useInternalProcessing=chk_seek_useInternalProcessing.Checked;
		}
		void Num_GainMapTeilerValueChanged(object sender, EventArgs e)
		{
//			thermal.GainTeiler=(ushort)num_GainMapTeiler.Value;
		}
		void Chk_qualiLogCheckedChanged(object sender, EventArgs e)
		{
	
		}
		void Timer_rawframeTick(object sender, EventArgs e)
		{
	
		}
		void But_cal_gernerateMapClick(object sender, EventArgs e)
		{
		 	bool resp = thermal.Generate2PointMaps("Cal_Low_Frame.dat","Cal_Hi_Frame.dat");
		 	if (resp) {
		 		but_cal_gernerateMap.BackColor=Color.LimeGreen;
		 		chk_cal_useGainOffsetCal.Checked=true;
		 	} else {
		 		but_cal_gernerateMap.BackColor=Color.Red;
		 	}
		}
		void Btn_calGetLowFrameClick(object sender, EventArgs e)
		{
			thermal.Cal_Low_Frame=thermal.LastFrame;
			thermal.SaveFrameToFile("Cal_Low_Frame.dat",true);
		}
		void Btn_calGetHiFrameClick(object sender, EventArgs e)
		{
			thermal.Cal_Hi_Frame=thermal.LastFrame;
			thermal.SaveFrameToFile("Cal_Hi_Frame.dat",true);
		}
		void Chk_cal_useGainOffsetCalCheckedChanged(object sender, EventArgs e)
		{
			thermal.UseGainOffsetCal=chk_cal_useGainOffsetCal.Checked;
		}
		void Button7Click(object sender, EventArgs e)
		{
			short[,] RefMap = thermal.LastFrame.GetOffsetMap(thermal.DeathPixMap);
			thermal.Shift_OffsetMap(RefMap);
		}
		void CheckBox1CheckedChanged(object sender, EventArgs e)
		{
//			thermal.GetRADC=checkBox1.Checked;
		}
		ushort[,] MatchBase;
		void Btn_getMatchClick(object sender, EventArgs e)
		{
			MatchBase = new ushort[picBox_match.Width,picBox_match.Height];
			int newX=0,newY=0;
			int stopX=(int)num_IP_MatchX.Value+picBox_match.Width;
			int stopY=(int)num_IP_MatchY.Value+picBox_match.Height;
			for (int y = (int)num_IP_MatchY.Value; y < stopY; y++) {
				newX=0;
                for (int x = (int)num_IP_MatchX.Value; x < stopX; x++) {
					MatchBase[newX,newY] = VARs.TempRaw[x,y];
					newX++;
                }
				newY++;
            }
			ushort max=(ushort)trackBar_max.Value;
        	ushort min=(ushort)trackBar_min.Value;
			UnsafeBitmap ubmp = new UnsafeBitmap(picBox_match.Width,picBox_match.Height);
			PixelData Col = new PixelData();
			// Scale data to be within [0-255] for LUT mapping.
        	ushort maxmin = (ushort)(max-min);
            if (maxmin<10) { maxmin=10; }// Avoid divide by 0
            ubmp.LockBitmap();
            for (int y = 0; y < picBox_match.Height; y++) {
                for (int x = 0; x < picBox_match.Width; x++) {
                    int v = MatchBase[x,y];
                    
                    v = (v - min) * 256 / maxmin;
                    if (v < 0) { v = 0; } if (v > 255) {  v = 255; }
                    
                    Col.red=(byte)v;
	                Col.green=(byte)v;
	                Col.blue=(byte)v;
                    ubmp.SetPixel(x, y, Col);
                }
            }
        	ubmp.UnlockBitmap();
        	picBox_match.Image=(Bitmap)ubmp.Bitmap.Clone();
		}
		void Chk_BilatSmoothCheckedChanged(object sender, EventArgs e)
		{
	
		}

		void PicBoxMainMouseHover(object sender, EventArgs e)
		{
	
		}
		void PicBoxMainMouseMove(object sender, MouseEventArgs e)
		{
			try {
				int X = (int)(((float)e.X/(float)PicBoxMain.Width)*(float)PicBoxMain.Image.Width);
				int Y = (int)(((float)e.Y/(float)PicBoxMain.Height)*(float)PicBoxMain.Image.Height);
				ushort val = VARs.TempRaw[X,Y];
				Label_Mauspositon.Text=X.ToString()+" / "+Y.ToString()+"   "+val.ToString();
			} catch (Exception err) {
				Label_Mauspositon.Text=err.Message;
			}
		}
		
		
		
		public delegate void invokeDelegate();
		
		TcpServer tcpServer1 = new TcpServer();
		void Btn_SetPortClick(object sender, EventArgs e)
		{
			try {
				openTcpPort();
				timer_TCP.Enabled=true;
			} catch (Exception err) {
				MessageBox.Show(err.Message);
			}
		}
		void openTcpPort()
        {
            tcpServer1.Close();
            tcpServer1.Port = Convert.ToInt32(txtPort.Text);
            txtPort.Text = tcpServer1.Port.ToString();
            tcpServer1.Open();

            displayTcpServerStatus();
        }
        void displayTcpServerStatus()
        {
            if (tcpServer1.IsOpen) {
                lblStatus.Text = "PORT OPEN";
                if (tcpServer1.Connections.Count==0) {
                	lblStatus.BackColor = Color.Gold;
                	writeoffset=0;frameDroped=0;
                } else {
                	lblStatus.BackColor = Color.Lime;
                }
                
                txt_IP.Text=tcpServer1.localIP;
            } else {
                lblStatus.Text = "PORT NOT OPEN";
                lblStatus.BackColor = Color.Red;
            }
        }
		void BtnSendClick(object sender, EventArgs e)
		{
			send();
		}
        void send()
        {
            string data = "";

            foreach (string line in txtText.Lines)
            {
                data = data + line.Replace("\r", "").Replace("\n", "") + "\r\n";
            }
            data = data.Substring(0, data.Length - 2);

            tcpServer1.Send(data);

            logData(true, data);
        }
		StringBuilder SB = new StringBuilder();
        public void logData(bool sent, string text)
        {
        	if (sent) {
        		return;
        	}
        	SB.Append(text);
        	label_sens_lo.Text=SB.Length.ToString();
        }
        public void logData2(byte[] dataArray)
        {
        	if (isDrawing) {
        		frameDroped++;
        		return;
        	}
        	isDrawing = true;
        	ThermalFrame TF = new ThermalFrame(2,dataArray,160,120);
        	SeekStream_GetByteArray(TF);
        	isDrawing = false;
        }
        bool isDrawing = false;
        int frameDroped = 0;
		void Timer_TCPTick(object sender, EventArgs e)
		{
			displayTcpServerStatus();
            lblConnected.Text = tcpServer1.Connections.Count.ToString();
            
            if (tcpServer1.Connections.Count!=listBox_users.Items.Count) {
            	listBox_users.Items.Clear();
            	//string remoteIP;
            	for (int i = 0; i < tcpServer1.Connections.Count; i++) {
	            	using (Socket socket = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, 0))
					{
					    socket.Connect("8.8.8.8", 65530);
					    System.Net.IPEndPoint endPoint = tcpServer1.Connections[0].Socket.Client.RemoteEndPoint as System.Net.IPEndPoint;
					    listBox_users.Items.Add(endPoint.Address.ToString());
					}
            	}
				
            }
		}
		
		byte[] FrameArray = new byte[(160*120*2)+6];
		int writeoffset = 0;
		void tcpServer1_OnDataAvailable(tcpServer.TcpServerConnection connection)
        {
            byte[] data = readStream(connection.Socket);
//			if (data != null)
//            {
//                string dataStr = Encoding.ASCII.GetString(data);
//                invokeDelegate del = () =>
//                {
//                    logData(false, dataStr);
//                };
//                Invoke(del);
//                data = null;
//            }
            if (data != null)
            {
            	foreach (byte B in data) {
            		FrameArray[writeoffset]=B;
            		writeoffset++;
            		if (writeoffset==FrameArray.Length-2) {
            			//MessageBox.Show("fertig");
            			invokeDelegate del = () =>
                		{ logData2(FrameArray); };
                		Invoke(del);
                		writeoffset=0;//reset
            		}
            	}
            	data = null;
            }
        }
		protected byte[] readStream(TcpClient client)
        {
            NetworkStream stream = client.GetStream();
            if (stream.DataAvailable)
            {
                byte[] data = new byte[client.Available];

                int bytesRead = 0;
                try
                {
                    bytesRead = stream.Read(data, 0, data.Length);
                }
                catch (IOException)
                {
                }

                if (bytesRead < data.Length)
                {
                    byte[] lastData = data;
                    data = new byte[bytesRead];
                    Array.ConstrainedCopy(lastData, 0, data, 0, bytesRead);
                }
                return data;
            }
            return null;
        }
		
		void tcpServer1_OnConnect(tcpServer.TcpServerConnection connection)
        {
			invokeDelegate setText = () => lblConnected.Text = tcpServer1.Connections.Count.ToString();
            Invoke(setText);
        }
		void Button3Click(object sender, EventArgs e)
		{
			UdpClient UD = new UdpClient();
		
			//tcpServer1.Connections[0].Socket.Client.RemoteEndPoint
			string localIP;
			using (Socket socket = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, 0))
			{
			    socket.Connect("8.8.8.8", 65530);
			    System.Net.IPEndPoint endPoint = tcpServer1.Connections[0].Socket.Client.RemoteEndPoint as System.Net.IPEndPoint;
			    localIP = endPoint.Address.ToString();
			}
			MessageBox.Show(localIP);
		}
    }
}
